import Cocoa

@objc(NSObject) protocol DIMBridge {  // protocol to bridge to AppleScriptObjC- thanks to https://github.com/hhas/Swift-AppleScriptObjC
    
    var iconSet: Any { get set }             // array of applescript arrays [ [iconNames], [iconPositions], [screenSize] ], used both for getting and setting
    var numArrangement: NSNumber { get set } // returns stored number of icons on desktop (does not compute)- only use get, but seems set is required (but not used)
    var numDesktop: NSNumber { get set }     // returns stored number of icons in the current iconSet- only use get, but seems set is required (but not used)

    func numOnDesktop() // set number of icons on desktop by asking Finder, this is an AppleScript function
    func numInSet()     // sets number of icons in iconSet by asking Finder to count items in iconSet, this is an AppleScript function
    func memorize()     // This grabs required data from Finder through AppleScript, sets iconSet, numArrangement and numDesktop, this is a function (no return value)
    func restore()      // This tells the Finder to restore icons through AppleScript positions according to current iconSet and updates numArrangment, this is a function (no return value)
    func showNewIcons() // This tells the Finder to select unmemorized icons on the desktop
    
    var testBridge: NSString { get }
}
